<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Usuarios</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas consultar la información de algún usuario?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-card :max-width="1000" class="mx-auto">
        <v-toolbar dark class="white--text" color="primary">
          <v-btn icon>
            <v-icon x-large>mdi-account-supervisor</v-icon>
          </v-btn>
          <v-toolbar-title>Usuarios</v-toolbar-title>
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            label="Buscar"
            flat
            dark
            solo-inverted
            append-icon="mdi-magnify"
            hide-details
            clear-icon="mdi-close-circle-outline"
          ></v-text-field>
          <v-btn icon>
            <v-icon>mdi-dots-vertical</v-icon>
          </v-btn>
        </v-toolbar>
        <v-row justify="space-between">
          <v-col class="pb-0 pr-0" cols="5">
            <v-card
              dense
              :min-height="800"
              :max-height="800"
              style="overflow: auto;"
            >
              <v-list subheader>
                <v-list-item-group color="primary" v-model="selected">
                  <v-subheader>Directorio</v-subheader>
                  <template v-for="(empleado, index) in usuarios">
                    <v-divider :key="'divider-' + index" />
                    <v-list-item :key="'item-' + index" :value="empleado">
                      <v-list-item-avatar>
                        <v-icon x-large>mdi-account-circle</v-icon>
                      </v-list-item-avatar>
                      <v-list-item-content>
                        <v-list-item-title
                          v-text="empleado.nombre_usuario"
                        ></v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </template>
                  <v-divider />
                </v-list-item-group>
                <v-list-item v-if="loading">
                  <div class="text-center">
                    <v-progress-circular
                      :size="100"
                      color="primary"
                      class="progress-circular"
                      indeterminate
                    ></v-progress-circular>
                  </div>
                </v-list-item>
                <v-list-item>
                  <v-list-item-content>
                    <v-list-item-title v-if="!search">
                      Realiza alguna busqueda...!
                    </v-list-item-title>
                    <v-list-item-title
                      v-else-if="usuarios && usuarios.length == 0"
                    >
                      No se han encontrado resuldados...!
                    </v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-list>
            </v-card>
          </v-col>
          <v-divider vertical></v-divider>
          <v-col class="d-flex text-center">
            <v-scroll-y-transition mode="out-in">
              <div
                v-if="!selected"
                class="title grey--text text--lighten-1 font-weight-light"
                style="align-self: center;"
              >
                Selecciona un Usuario
              </div>
              <v-card
                v-else
                :key="selected.id_usuario"
                class="pt-6 mx-auto"
                flat
                max-width="400"
              >
                <v-card-text>
                  <v-avatar
                    :color="selected.color"
                    class="white--text"
                    size="65"
                  >
                    {{ selected.initials }}
                  </v-avatar>
                  <h3 class="headline mb-2">
                    <router-link :to="selected.to" class="nav-link">
                      {{ selected.nombre_usuario }}
                    </router-link>
                  </h3>
                  <div class="mb-2">{{ selected.correo }}</div>
                  <div class="subheading font-weight-bold">
                    Empleado : {{ selected.id_usuario }}
                  </div>
                </v-card-text>
                <v-card-actions>
                  <v-btn
                    :to="selected.to"
                    text
                    x-small
                    class="float-right"
                    icon
                  >
                    <v-icon small>mdi-open-in-new</v-icon>
                  </v-btn>
                </v-card-actions>
                <v-chip
                  v-for="(perfilUsuario, indexPerfil) in selected.perfiles"
                  :key="indexPerfil"
                >
                  {{ perfilUsuario.perfil.descripcion }}
                </v-chip>
                <v-divider></v-divider>
              </v-card>
            </v-scroll-y-transition>
          </v-col>
        </v-row>
      </v-card>
    </div>
  </div>
</template>
<style scoped>
.nav-link {
  text-decoration: underline;
  color: inherit;
}
.progress-circular {
  position: initial;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
import moment from "moment";
const colors = [
  "#2196F3",
  "#90CAF9",
  "#64B5F6",
  "#42A5F5",
  "#1E88E5",
  "#1976D2",
  "#1565C0",
  "#0D47A1",
  "#82B1FF",
  "#448AFF",
  "#2979FF",
  "#2962FF",
];

export default {
  name: "Component-Usuarios",
  data() {
    return {
      moment: moment,
      loading: false,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios",
          },
        },
        {
          text: "Usuarios",
          disabled: true,
        },
      ],
      selected: null,
      usuarios: [],
      search: null,
      caseSensitive: false,
    };
  },
  watch: {
    search(val, prev) {
      this.loading = true;
      if (val && val.length > 3) {
        this.fetchUsers();
      } else {
        this.usuarios = [];
        setTimeout(() => {
          this.loading = false;
        }, 100);
      }
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    colorsLength() {
      return colors.length;
    },
    filter() {
      return this.caseSensitive
        ? (item, search, textKey) => item[textKey].indexOf(search) > -1
        : undefined;
    },
  },
  methods: {
    genRandomIndex(length) {
      return Math.ceil(Math.random() * (length - 1));
    },
    async fetchUsers() {
      var self = this;
      return axios
        .get("/usuario/secure/get/perfiles?empleado=" + this.search)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setUsuarios(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.loading = false;
        });
    },
    setUsuarios(data) {
      if (data) {
        data.forEach((itemUsuario, indexItemUsuario) => {
          let nombreUsuario =
            "" + this.serviceCommons.titleCase(itemUsuario.nombre_usuario);
          itemUsuario.nombre_usuario =
            itemUsuario.id_usuario + " - " + nombreUsuario;
          itemUsuario.initials = this.serviceCommons.initialLetters(
            nombreUsuario
          );
          itemUsuario.no = indexItemUsuario + 1;
          itemUsuario.color = colors[this.genRandomIndex(this.colorsLength)];
          let usuario = {
            id_usuario: itemUsuario.id_usuario,
            nombre_usuario: itemUsuario.nombre_usuario,
            perfiles: itemUsuario.perfiles,
          };
          itemUsuario.to = {
            name: "privilegios_usuario_perfiles",
            params: {
              usuario: this.serviceCommons.objectToBase64(usuario),
            },
          };
        });
        this.usuarios = data;
      }
    },
  },
};
</script>
